#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>

int i;
mpz_t p[22], x[100];
mpz_t factorbase[12]; 
mpz_t xfb[100][12]; //values of the exponents for x[i]
mpz_t n, q;
char stillfactoring=1;

//Initialize factorbase to 0, define primes used for factorbase
void setup(mpz_t p[])
{
  int k;
  //initialize x[][]
  for(i=0; i<100; i++)
  {
    for(k=0; k<12; k++)
    {
      mpz_init_set_ui(xfb[i][k],0);
    }
  }
  //Load primes in the p[].
  for(i=0; i<21; i++)
  {
    mpz_init(p[i]);
    if(i<12)
      mpz_init_set_ui(factorbase[i],0);
    switch(i)
    {
      case 0:
        mpz_set_ui(p[i], 2);
      break;  

      case 1:
        mpz_set_ui(p[i], 3);
      break;

      case 2:
        mpz_set_ui(p[i], 5);
      break;

      case 3:
        mpz_set_ui(p[i], 7);
      break;

      case 4:
        mpz_set_ui(p[i], 11);
      break;

      case 5:
        mpz_set_ui(p[i], 13);
      break;

      case 6:
        mpz_set_ui(p[i], 17);
      break;

      case 7:
        mpz_set_ui(p[i], 19);
      break;

      case 8:
        mpz_set_ui(p[i], 23);
      break;

      case 9:
        mpz_set_ui(p[i], 29);
      break;

      case 10:
        mpz_set_ui(p[i], 31);
      break;

      case 11:
        mpz_set_ui(p[i], 37);
      break;
      
      case 12:
        mpz_set_ui(p[i], 41);
      break;

      case 13:
        mpz_set_ui(p[i], 43);
      break;
      
      case 14:
        mpz_set_ui(p[i], 47);
      break;

      case 15:
        mpz_set_ui(p[i], 51);
      break;
      
      case 16:
        mpz_set_ui(p[i], 53);
      break;

      case 17:
        mpz_set_ui(p[i], 59);
      break;
      
      case 18:
        mpz_set_ui(p[i], 61);
      break;

      case 19:
        mpz_set_ui(p[i], 71);
      break;
      
      case 20:
        mpz_set_ui(p[i], 73);
      break;

      case 21:
        mpz_set_ui(p[i], 79);
      break;    
    }
  }
}
//{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37} is the factor base prime set


void buildfactorbase(mpz_t n, mpz_t p[])
{
  int j=0;
  i=0;
  int tmp;
  while(i<22 && j != 11)
  {
    if(mpz_legendre(p[i], n) == 1)
    {
      mpz_set(factorbase[j], p[i]);
      gmp_printf("FB is %Zd\n", factorbase[j]);
      j++;
    }
    i++;
  }
}

int main()
{
  mpz_init_set_str(n, "6959134226532674994249593677847673686058492067595973577714142903358864871085491740976386206716162087833658553351841419497695059592816379969488636611839889120617457729863385741415821043347779489181173876153080209296019", 10);
  
  /*start testing square root floor code
  mpz_init_set_str(t1, "55", 10);
  mpz_init(t2);
  mpz_sqrt(t2, t1);
  gmp_printf("%Zd\n", t2);
  end testing*/
  
  setup(p);
  buildfactorbase(n, p);
    
  FILE *Fp;
  Fp = fopen("/home/no1/out.txt", "w");

  
  gmp_printf("%Zd\n", xfb[0]);

  for(i=0; i<100; i++)
  {
    mpz_sqrt(x[i], n);
    mpz_add_ui(x[i], x[i], i);
    mpz_powm_ui(q, x[i], 2, n);
    
    //factor q
    while(stillfactoring)
    {
      printf("in the while loop\n");
      if(mpz_divisible_p(q, factorbase[0]) != 0)
      {
        printf("inside first if statement\n");
        mpz_divexact(q, q, factorbase[0]);
        printf("beat the divexact\n");
        mpz_add_ui(xfb[i][0], xfb[i][0], 1);
        printf("after mpz_add_ui");
      }
      printf("fuck if statements");
      if(mpz_divisible_p(q, factorbase[1]) != 0)
      {
        mpz_divexact(q, q, factorbase[1]);
        mpz_add_ui(xfb[i][1], xfb[i][1], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[2]) != 0)
      {
        mpz_divexact(q, q, factorbase[2]);
        mpz_add_ui(xfb[i][2], xfb[i][2], 1);
        //printf("I'm in one");
      }

      if(mpz_divisible_p(q, factorbase[3]) != 0)
      {
        mpz_divexact(q, q, factorbase[4]);
        mpz_add_ui(xfb[i][3], xfb[i][3], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[4]) != 0)
      {
        mpz_divexact(q, q, factorbase[4]);
        mpz_add_ui(xfb[i][4], xfb[i][4], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[5]) != 0)
      {
        mpz_divexact(q, q, factorbase[5]);
        mpz_add_ui(xfb[i][5], xfb[i][5], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[6]) != 0)
      {
        mpz_divexact(q, q, factorbase[6]);
        mpz_add_ui(xfb[i][6], xfb[i][6], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[7]) != 0)
      {
        mpz_divexact(q, q, factorbase[7]);
        mpz_add_ui(xfb[i][7], xfb[i][7], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[8]) != 0)
      {
        mpz_divexact(q, q, factorbase[8]);
        mpz_add_ui(xfb[i][8], xfb[i][8], 1);
        //printf("I'm in one");
      }      
      if(mpz_divisible_p(q, factorbase[9]) != 0)
      {
        mpz_divexact(q, q, factorbase[9]);
        mpz_add_ui(xfb[i][9],xfb[i][9], 1);
        //printf("I'm in one");
      }      
      if(mpz_divisible_p(q, factorbase[10]) != 0)
      {
        mpz_divexact(q, q, factorbase[10]);
        mpz_add_ui(xfb[i][10],xfb[i][10], 1);
        //printf("I'm in one");
      }
      if(mpz_divisible_p(q, factorbase[11]) != 0)
      {
        mpz_divexact(q, q, factorbase[11]);
        mpz_add_ui(xfb[i][11],xfb[i][11], 1);
        //printf("I'm in one");
      }
      else
        stillfactoring = 0;
    }
    //print value of x[i] and exponents xfb[i][]
    gmp_fprintf(Fp, "%Zd %s %Zd %Zd %Zd %Zd %Zd %Zd %Zd %Zd %Zd %Zd %Zd %Zd\n", x[i], " with factor base: ", xfb[i][0], xfb[i][1], xfb[i][2], xfb[i][3], xfb[i][4], xfb[i][5], xfb[i][6], xfb[i][7], xfb[i][8], xfb[i][9], xfb[i][10], xfb[i][11]);
  }  

  fclose(Fp);
  return 0;
}
